//UnbenutzteFormate_305d.js
// 16.09.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Unbenutzte Formate werden gelscht

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// die Programmversion feststellen
var appVers = app.version[0];
if (appVers != 5) {
	if (appVers == 4) {
		alert ("Fr InDesign CS2\nbitte die entsprechende Version des Scripts benutzen.", "Achtung");
	}
	else if (appVers == 6) {
		alert ("Fr InDesign CS4\nbitte die entsprechende Version des Scripts benutzen.", "Achtung");
	}
	else {
		alert ("Dieses Script nur mit InDesign CS3 benutzen.", "Achtung");
	}
	exit();
}

// eine Referenz zum vordersten Dokument
var curDoc = app.documents[0];

// prfen, ob Absatzformat-Gruppen bestehen
paraGroups = curDoc.paragraphStyleGroups;
var nPSG = paraGroups.length;

// prfen, ob Zeichenformat-Gruppen bestehen
charGroups = curDoc.characterStyleGroups;
var nCSG = charGroups.length;

// prfen, ob Objektstil-Gruppen bestehen
objtGroups = curDoc.objectStyleGroups;
var nOSG = objtGroups.length;

// Variablen initialisieren
var noParaStyle = curDoc.paragraphStyles[0].name;
var dfParaStyle = curDoc.paragraphStyles[1].name;
var noCharStyle = curDoc.characterStyles[0].name;
var cCtr = 0;
var pCtr = 0;

// die Absatzformate speichern
var pStyles;
var ps00 = curDoc.paragraphStyles;
var psLists = new Array (ps00);
for (var i=0; i<nPSG; i++) {
	pStyles = curDoc.paragraphStyleGroups[i].paragraphStyles;
	psLists.push(pStyles);
}

// die Zeichenformate speichern
var cStyles;
var cs00 = curDoc.characterStyles;
var csLists = new Array (cs00);
for (var i=0; i<nCSG; i++) {
	cStyles = curDoc.characterStyleGroups[i].characterStyles;
	csLists.push(cStyles);
}

// die Absatzformatgruppenlisten vorbereiten
var pg00 = new Array ();
var pGroupLists = new Array (pg00);
for (var i=0; i<nPSG; i++) {
	pGroupLists.push(new Array ());
}

// die Zeichenformatgruppenlisten vorbereiten
var cg00 = new Array ();
var cGroupLists = new Array (cg00);
for (var i=0; i<nCSG; i++) {
	cGroupLists.push(new Array ());
}

// die Liste(n) der Absatzformate, welche als "Basiert auf" und/oder 
// "Nchstes Format" eingetragen sind, erstellen
var allParaStyles, nParaStyles;
var curProps, curPName, bas, basProps, bnm, par, pg, nxt, nxtProps, nnm;
for (var i=0; i<(nPSG+1); i++) {
	allParaStyles = psLists[i];
	nParaStyles = allParaStyles.length;
	for (var p=0; p<nParaStyles; p++) {
		curProps = allParaStyles[p].properties;
		curPName = curProps.name;
		try {
			bas = curProps.basedOn;
			basProps = bas.properties;
			bnm = basProps.name;
			if (bnm != undefined && bnm != dfParaStyle) {
				par = basProps.parent;
				if (par == "[object Document]") {
					pg = 0;
				}
				else {
					pg = (par.index) + 1;
				}
				if (!isInArray(bnm, pGroupLists[pg])) {
					pGroupLists[pg].push(bnm);
				}
			}
		}
		catch (e) {
		}
		try {
			nxt = curProps.nextStyle;
			nxtProps = nxt.properties;
			nnm = nxtProps.name;
			if (nnm != undefined && nnm != dfParaStyle) {
				par = nxtProps.parent;
				if (par == "[object Document]") {
					pg = 0;
				}
				else {
					pg = (par.index) + 1;
				}
				if (nnm == curPName && pg != i || nnm != curPName) {
					if (!isInArray(nnm, pGroupLists[pg])) {
						pGroupLists[pg].push(nnm);
					}
				}
			}
		}
		catch (e) {
		}
	}
}

// in Objektstilen verwendete Absatzformate einbeziehen
var allObjectStyles;
var nObjStyles, obj, objProps, obn;
for (var i=0; i<(nOSG+1); i++) {
	if (i==0) {
		allObjectStyles = curDoc.objectStyles;
	}
	else {
		allObjectStyles = curDoc.objectStyleGroups[i-1].objectStyles;
	}
	nObjStyles = allObjectStyles.length;
	for (var o=0; o<nObjStyles; o++) {
		try {
			obj = allObjectStyles[o].appliedParagraphStyle;
			objProps = obj.properties;
			obn = objProps.name;
			if (obn != undefined && obn != noParaStyle && obn != dfParaStyle) {
				par = objProps.parent;
				if (par == "[object Document]") {
					pg = 0;
				}
				else {
					pg = (par.index) + 1;
				}
				if (!isInArray(obn, pGroupLists[pg])) {
					pGroupLists[pg].push(obn);
				}
			}
		}
		catch (e) {
		}
	}
}

// auch die Namen der im Dokument verwendeten Absatzformate an die Liste(n) anhngen
var allStories = curDoc.stories;
var nStories = allStories.length;
var allStyles, nStyles, curStyle, cnm;
for (var i=0; i<nStories; i++) {
	if (allStories[i].length >0) {
		try {
			allStyles = allStories[i].paragraphs.everyItem().appliedParagraphStyle;
			nStyles = allStyles.length;
			for (var s=0; s<nStyles; s++) {
				curStyle = allStyles[s];
				curProps = curStyle.properties;
				cnm = curProps.name;
				if (cnm != noParaStyle && cnm != dfParaStyle) {
					par = curProps.parent;
					if (par == "[object Document]") {
						pg = 0;
					}
					else {
						pg = (par.index) + 1;
					}
					if (!isInArray(cnm, pGroupLists[pg])) {
						pGroupLists[pg].push(cnm);
					}
				}
			}
		}
		catch (e) {
		}
	}
	else {
		try {
			curStyle = allStories[i].insertionPoints[0].appliedParagraphStyle;
			curProps = curStyle.properties;
			cnm = curProps.name;
			if (cnm != noParaStyle && cnm != dfParaStyle) {
				par = curProps.parent;
				if (par == "[object Document]") {
					pg = 0;
				}
				else {
					pg = (par.index) + 1;
				}
				if (!isInArray(cnm, pGroupLists[pg])) {
					pGroupLists[pg].push(cnm);
				}
			}
		}
		catch (e) {
		}
	}
}

// Absatzformate, welche in Tabellen verwendet werden
try {
	var tabPStyles = allStories.everyItem().tables.everyItem().cells.everyItem().texts[0].paragraphs.everyItem().appliedParagraphStyle;
	nStyles = tabPStyles.length;
	for (var t=0; t<nStyles; t++) {
		curStyle = tabPStyles[t];
		curProps = curStyle.properties;
		cnm = curProps.name;
		if (cnm != noParaStyle && cnm != dfParaStyle) {
			par = curProps.parent;
			if (par == "[object Document]") {
				pg = 0;
			}
			else {
				pg = (par.index) + 1;
			}
			if (!isInArray(cnm, pGroupLists[pg])) {
				pGroupLists[pg].push(cnm);
			}
		}
	}
}
catch (e) {
}

// Absatzformate, welche in Fussnoten verwendet werden
try {
	var footPStyles = allStories.everyItem().footnotes.everyItem().texts[0].paragraphs.everyItem().appliedParagraphStyle;
	nStyles = footPStyles.length;
	for (var f=0; f<nStyles; f++) {
		curStyle = footPStyles[f];
		curProps = curStyle.properties;
		cnm = curProps.name;
		if (cnm != noParaStyle && cnm != dfParaStyle) {
			par = curProps.parent;
			if (par == "[object Document]") {
				pg = 0;
			}
			else {
				pg = (par.index) + 1;
			}
			if (!isInArray(cnm, pGroupLists[pg])) {
				pGroupLists[pg].push(cnm);
			}
		}
	}
}
catch (e) {
}

// eine Schleife durch die Absatzformate der Absatzformatgruppen; 
// Format lschen, wenn es sich nicht in der Liste "verwendet" befindet
var allParaNames;
for (var i=0; i<(nPSG+1); i++) {
	allParaStyles = psLists[i];
	allParaNames = allParaStyles.everyItem().name;
	nParaStyles = allParaStyles.length;
	for (var p=nParaStyles-1; p>-1; p--) {
		curPName = allParaNames[p];
		if (!isInArray(curPName, pGroupLists[i])) {
			try {
				if (i==0) {
					curDoc.paragraphStyles[p].remove();
					pCtr++;
				}
				else {
					curDoc.paragraphStyleGroups[i-1].paragraphStyles[p].remove();
					pCtr++;
				}
			}
			catch (e) {
			}
		}
	}
}

// die Liste der Zeichenformate, welche als "Basiert auf" eingetragen sind, erstellen
var allCharStyles, nCharStyles;
var curCName, cg;
for (var i=0; i<(nCSG+1); i++) {
	allCharStyles = csLists[i];
	var nCharStyles = allCharStyles.length;
	for (var c=0; c<nCharStyles; c++) {
		curProps = allCharStyles[c].properties;
		curCName = curProps.name;
		try {
			bas = curProps.basedOn;
			basProps = bas.properties;
			bnm = basProps.name;
			if (bnm != undefined && bnm != noCharStyle) {
				par = basProps.parent;
				if (par == "[object Document]") {
					cg = 0;
				}
				else {
					cg = (par.index) + 1;
				}
				if (!isInArray(bnm, cGroupLists[cg])) {
					cGroupLists[cg].push(bnm);
				}
			}
		}
		catch (e) {
		}
	}
}

// die Zeichenformate, welche als Hngende Initialen 
// und/oder in verschachtelten Formaten 
// und/oder als Aufzhlungszeichen verwendet werden, anhngen
var allNes, nes, nesProps, bcs, bcsProps;
for (var i=0; i<(nPSG+1); i++) {
	if (i==0) {
		allParaStyles = curDoc.paragraphStyles;
	}
	else {
		allParaStyles = curDoc.paragraphStyleGroups[i-1].paragraphStyles;
	}
	var nParaStyles = allParaStyles.length;
	for (var p=0; p<nParaStyles; p++) {
		allNes = allParaStyles[p].nestedStyles;
		nStyles = allNes.length;
		for (var n=0; n<nStyles; n++) {
			try {
				nes = allNes[n].appliedCharacterStyle;
				nesProps = nes.properties;
				nnm = nesProps.name;
				if (nnm != noCharStyle) {
					par = nesProps.parent;
					if (par == "[object Document]") {
						cg = 0;
					}
					else {
						cg = (par.index) + 1;
					}
					if (!isInArray(nnm, cGroupLists[cg])) {
						cGroupLists[cg].push(nnm);
					}
				}
			}
			catch (e) {
			}
		}
		try {
			bcs = allParaStyles[p].bulletsCharacterStyle;
			bcsProps = bcs.properties;
			bnm = bcsProps.name;
			if (bnm != noCharStyle) {
				par = bcsProps.parent;
				if (par == "[object Document]") {
					cg = 0;
				}
				else {
					cg = (par.index) + 1;
				}
				if (!isInArray(bnm, cGroupLists[cg])) {
					cGroupLists[cg].push(bnm);
				}
			}
		}
		catch (e) {
		}
	}
}

// die im Dokument verwendeten Zeichenformate an die Liste anhngen
for (var i=0; i<nStories; i++) {
	if (allStories[i].length >0) {
		try {
			allCharStyles = allStories[i].textStyleRanges.everyItem().appliedCharacterStyle;
			nStyles = allCharStyles.length;
			for (var s=0; s<nStyles; s++) {
				curStyle = allCharStyles[s];
				curProps = curStyle.properties;
				cnm = curProps.name;
				if (cnm != noCharStyle) {
					par = curProps.parent;
					if (par == "[object Document]") {
						cg = 0;
					}
					else {
						cg = (par.index) + 1;
					}
					if (!isInArray(cnm, cGroupLists[cg])) {
						cGroupLists[cg].push(cnm);
					}
				}
			}
		}
		catch (e) {
		}
	}
	else {
		try {
			curStyle = allStories[i].insertionPoints[0].appliedCharacterStyle;
			curProps = curStyle.properties;
			cnm = curProps.name;
			if (cnm != noCharStyle) {
				par = curProps.parent;
				if (par == "[object Document]") {
					cg = 0;
				}
				else {
					cg = (par.index) + 1;
				}
				if (!isInArray(cnm, cGroupLists[cg])) {
					cGroupLists[cg].push(cnm);
				}
			}
		}
		catch (e) {
		}
	}
}

// Zeichenformate, welche in Tabellen verwendet werden
try {
	var tabCStyles = allStories.everyItem().tables.everyItem().cells.everyItem().texts[0].textStyleRanges.everyItem().appliedCharacterStyle;
	nStyles = tabCStyles.length;
	for (var c=0; c<nStyles; c++) {
		curStyle = tabCStyles[s];
		curProps = curStyle.properties;
		cnm = curProps.name;
		if (cnm != noCharStyle) {
			par = curProps.parent;
			if (par == "[object Document]") {
				cg = 0;
			}
			else {
				cg = (par.index) + 1;
			}
			if (!isInArray(cnm, cGroupLists[cg])) {
				cGroupLists[cg].push(cnm);
			}
		}
	}
}
catch (e) {
}

// Zeichenformate, welche in Fussnoten verwendet werden
try {
	var footCStyles = allStories.everyItem().footnotes.everyItem().texts[0].textStyleRanges.everyItem().appliedCharacterStyle;
	nStyles = footCStyles.length;
	for (var c=0; c<nStyles; c++) {
		curStyle = footCStyles[s];
		curProps = curStyle.properties;
		cnm = curProps.name;
		if (cnm != noCharStyle) {
			par = curProps.parent;
			if (par == "[object Document]") {
				cg = 0;
			}
			else {
				cg = (par.index) + 1;
			}
			if (!isInArray(cnm, cGroupLists[cg])) {
				cGroupLists[cg].push(cnm);
			}
		}
	}
}
catch (e) {
}

// eine Schleife durch die Zeichenformate der Zeichenformatgruppen;
// Format lschen, wenn es sich nicht in der Liste "verwendet" befindet
var allCharNames;
for (var i=0; i<(nCSG+1); i++) {
	allCharStyles = csLists[i];
	allCharNames = allCharStyles.everyItem().name;
	nCharStyles = allCharStyles.length;
	for (var c=nCharStyles-1; c>-1; c--) {
		curName = allCharNames[c];
		if (!isInArray(curName, cGroupLists[i])) {
			try {
				if (i==0) {
					curDoc.characterStyles[c].remove();
					cCtr++;
				}
				else {
					curDoc.characterStyleGroups[i-1].characterStyles[c].remove();
					cCtr++;
				}
			}
			catch (e) {
			}
		}
	}
}

// leere Absatzformat-Ordner lschen
for (var p=nPSG-1; p>-1; p--) {
	var nGroups = paraGroups[p].paragraphStyleGroups.length;
	if (nGroups > 0) {
		continue;
	}
	var nStyles = paraGroups[p].paragraphStyles.length;
	if (nStyles == 0) {
		paraGroups[p].remove();
	}
}

// leere Zeichenformat-Ordner lschen
for (var c=nCSG-1; c>-1; c--) {
	var nGroups = charGroups[c].characterStyleGroups.length;
	if (nGroups > 0) {
		continue;
	}
	var nStyles = charGroups[c].characterStyles.length;
	if (nStyles == 0) {
		charGroups[c].remove();
	}
}

// den Anwender informieren
var totCtr = pCtr + cCtr;
if (totCtr == 0) {
	alert ("Keine Formate gelscht.", "Fertig");
}
else {
	if (totCtr == 1) {
		if (pCtr == 1) {
			alert ("Ein Absatzformat gelscht.", "Fertig");
		}
		else {
			alert ("Ein Zeichenformat gelscht.", "Fertig");
		}
	}
	else {
		alert ("Gelschte Formate:\t" + totCtr + "\n\nAbsatzformate:\t\t" + pCtr + "\nZeichenformate:\t" + cCtr, "Fertig");
	}
}

// die Funktion, welche prft, ob sich das aktuelle Element schon in der Liste befindet
function isInArray(curName, curArray) {
	for (var a=0; a<curArray.length; a++) {
		if(curArray[a] == curName) {
			return true;
		}
	}
	return false;
}